function [M,ans] = disappear_demo(LR,single,swap,swap2,ori)
% [M,ans] = rat_demo(LR,single,swap,ori)
%   LR = intial motion left or right
%   single = show only target (no distracter)
%   swap = do a rotation swap
%   swap2 = do second rotation swap
%   ori = 0-180, orientation of grating
%  returns M - matlab movie
%   answer = -1 for left, and 1 for right

 Ny=120;
 Nx=160;
 Bd=12;
 plotit = 0;
 Trio_kk = 1;   % total movies to build
 
 %*********************
 Tframes = 120;
 Mido = 75;
 if (swap == 0)
    Mido = 45;
    Tframes = Tframes - 30;;
 end
 if (swap2 == 0)
    Tframes = Tframes - 30;
 else
    Tframes = Tframes + 12;
 end
 Tframes = Tframes + 12;  % brief flash of stimuli
 %*********************
 ans = LR;
 if (swap == 1)
     ans = ans * -1;
 end
 if (swap2 ~= 0)
     ans = ans * -1;
 end
 %***************
 fcnt = 1;
 Trios = 1;   % determine number of movies directly 
 oldv = cell(1,Tframes);
 %***** tot stim space *************
 rand('seed',7);
 ObNum = 2;
 OboGo = ObNum;
 if (single == 1)
     OboGo = 1;
 end
 ObProps = zeros(ObNum,3);
 %**************
 ObProps(1,1) = (Nx/2);
 %ObProps(1,1) = (Nx/2) + (LR*0.3*Nx);
 ObProps(1,2) = (0.2*Ny); 
 %**************
 ObProps(2,1) = (Nx/2);
 %ObProps(2,1) = (Nx/2) - (LR*0.3*Nx);
 ObProps(2,2) = (0.8*Ny); 
 %**************
 ObProps(1:2,3) = ori;
 %**************
 Target = 4;
 
 %**********************************
 for kk = 1:Trios
       
   cnt = 1;
   stimlist = [];
   for i = 1:Tframes
     disp(sprintf('Computing frame %d',i));
     
     imo = 50 * ones(Nx,Ny); 
     for jj = 1:OboGo
     %*******************************************    
        xx = ObProps(jj,1);
        yy = ObProps(jj,2);
        or = ObProps(jj,3);
        as = 8;
        sf = 8;  
        pa = 0;
        si = 48;
        cur = 0;
        %******************
        if ( (i<(Tframes-9)) | (i>(Tframes-3)) )
          imo = gaboaspectplot(imo,xx,yy,8,as,sf,or,pa,si,cur,51);
        end
        %****************** cue central item
        if ( (i >= 6) & (i < 12) )
            if (jj == 1)
               y = find(imo < 45);
               imo(y) = 0;
               y = find(imo > 55);
               imo(y) = 100;
            end
        end
        %******************
     end
    
     %************* direction shift ********
     %***** front end of movie ************
     if (swap == 0)
       if ( (i>18) & (i<=33) )  % just make pause longer for now
         p = (i-18)/15;
         ObProps(1,1) = (Nx/2) + ((0.3*Nx)*sin( LR * (p^2)*(pi/2) ));
         ObProps(1,2) = ((0.2*Ny)*(1-p)) + (p*(0.5*Ny));
         ObProps(2,1) = (Nx/2) + ((0.3*Nx)*sin( -LR * (p^2)*(pi/2) ));
         ObProps(2,2) = ((0.8*Ny)*(1-p)) + (p*(0.5*Ny));
       end
       
     else
         
       if ( (i>18) & (i<=33) )
         p = (i-18)/15;
         ObProps(1,1) = (Nx/2) + ((0.3*Nx)*sin( LR * (p^2)*(pi/2) ));
         ObProps(1,2) = ((0.2*Ny)*(1-p)) + (p*(0.5*Ny));
         ObProps(2,1) = (Nx/2) + ((0.3*Nx)*sin( -LR * (p^2)*(pi/2) ));
         ObProps(2,2) = ((0.8*Ny)*(1-p)) + (p*(0.5*Ny));
       end  
       if ( (i>33) & (i<=63) )
           p = ((i-33)/30);
           ObProps(1,1) = (Nx/2) + LR * ((0.3*Nx)*cos( (p * pi) ));
           ObProps(1,2) = (Ny/2) + (1 * (0.2*Ny)*sin( (p * pi)  ));
           ObProps(2,1) = (Nx/2) - LR * ((0.3*Nx)*cos( (p * pi) ));
           ObProps(2,2) = (Ny/2) + (1 * (0.2*Ny)*sin( (-p * pi) ));
       end
     end  
     %******* first half moves up to 48 frames
     %*** then pause for 12 frames
     %******* and then move again
     if (swap2 == 0)
        if ( (i>Mido) & (i<=(Mido+15)) )
           p = (i-Mido)/15;
           ObProps(1,2) = ((0.5*Ny)*(1-p)) + (p*(0.2*Ny));
           ObProps(2,2) = ObProps(1,2);
        end
     else    
        if ( (i>Mido) & (i<=(Mido+30)) )
           p = ((i-Mido)/30);
           ObProps(1,1) = (Nx/2) + LR * ((0.3*Nx)*cos( (p * pi) ));
           ObProps(1,2) = (Ny/2) + (swap2 * (0.2*Ny)*sin( (p * pi)  ));
           ObProps(2,1) = (Nx/2) - LR * ((0.3*Nx)*cos( (p * pi) ));
           ObProps(2,2) = (Ny/2) + (swap2 * (0.2*Ny)*sin( (-p * pi) ));
         end
         if ( (i>(Mido+42)) & (i<=(Mido+57)) )
           p = (i-(Mido+42))/15;
           ObProps(1,2) = ((0.5*Ny)*(1-p)) + (p*(0.2*Ny));
           ObProps(2,2) = ObProps(1,2);
         end
     end
     
     %********** process v **********************
     z = find(imo < 0);
     imo(z) = 0;
     z = find(imo > 100);
     imo(z) = 100;
     %********* draw a fixation ******************
     midx = round(0.5*Nx);
     imo(midx,Bd) = 100;
     imo(midx-1,Bd) = 100;
     imo(midx+1,Bd) = 100;
     midx = round(0.2*Nx);
     imo(midx,Bd) = 100;
     imo(midx-1,Bd) = 100;
     imo(midx+1,Bd) = 100;
     midx = round(0.8*Nx);
     imo(midx,Bd) = 100;
     imo(midx-1,Bd) = 100;
     imo(midx+1,Bd) = 100;
     %********************************************
     imagesc(fliplr(imo)',[0 100]);
     colormap('gray');
     axis square;
     axis off;
     M(cnt) = getframe;
     %*******************************************
     cnt = cnt + 1;
   end
   Trio_kk = Trio_kk + 1;
   %*******************************************
   movie(M,1,30);
 end

return;


